searchNodes=[{"doc":"Library to help testing Absinthe graphql queries.It has several features to aid in testing:precompile queries during compile timeuse sigils for less verbose syntaxgenerates functions for named graphql operationsInstallationThe package can be installed by adding artem to your list of dependencies in mix.exs:def deps do [ {:artem, &quot;~&gt; 1.0.0&quot;} ] endUsageAdd the Artem module with the use clause. You'll need to supply the schema: option with the Absinthe schema under test.defmodule ArtemTest do use ExUnit.Case use Artem, schema: Your.Absinthe.Schema endNow you get access to the macros supplied by Artem. There are a couple of ways to use themSigilsThe first approach is using sigilsdefmodule ArtemTest do #... @version_query ~q&quot; query { version } &quot; test &quot;run query&quot; do assert {:ok, %{data: %{&quot;version&quot; =&gt; &quot;201008&quot;}}} == Artem.run(@version_query) end This precompiles the document into the @version_query module attribute. If you run this document multiple times in your tests you'll only have to run the static parts (parsing/some validation) of the document once. This can also be used outside of testing, if your app relies on internal graphql queries for example.Generated functionsThe second approach builds on this but when your graphql operations are named they are compiled into functions you can call.defmodule ArtemTest do #... ~q&quot; query MyTest($format: String{ datetime(format: $format) } &quot; test &quot;run query&quot; do assert {:ok, %{data: %{&quot;datetime&quot; =&gt; &quot;201008&quot;}}} == my_test(variables: %{format: &quot;YYMMDD&quot;}, context: %{current_user_id: 1}) end You can pass in the variables/context into the function.Note that the name of the function is snake_cased from the camelized name of the operation.precompile/2The third way is using the precompile/2 macrodefmodule ArtemTest do #... @query precompile(&quot; query { version } &quot;) test &quot;run query&quot; do assert {:ok, %{data: %{&quot;version&quot; =&gt; &quot;201008&quot;}}} == Artem.run(@query) end The sigil is syntactic sugar for calling the precompile macro. You can use this for more direct control over this process, allowing easier composability.Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/artem.","ref":"Artem.html","title":"Artem","type":"module"},{"doc":"Assign a context to the current query, e.g. set a current_user_idExamplesdefmodule SomeTest do use Artem, schema: Your.Schema @query ~q| query { version } | test &quot;runs precompiled query&quot; do @query |&gt; Artem.assign_context(%{current_user_id: 1}) |&gt; Artem.run() end end","ref":"Artem.html#assign_context/2","title":"Artem.assign_context/2","type":"function"},{"doc":"Assign variables to the current query, to pass them to the graphql queryExamplesdefmodule SomeTest do use Artem, schema: Your.Schema @query ~q| query($format: String{ datetime(format: $format) } | test &quot;runs precompiled query&quot; do @query |&gt; Artem.assign_variables(%{format: &quot;YYMMDD}) |&gt; Artem.run() end end","ref":"Artem.html#assign_vars/2","title":"Artem.assign_vars/2","type":"function"},{"doc":"Default pipeline called for the schemaCan be overridden by supplying a {module, function} tuple ## Examples defmodule SomeTest do use Artem, schema: Your.Schema, pipeline: {Your.Schema, :your_pipeline}","ref":"Artem.html#default_pipeline/2","title":"Artem.default_pipeline/2","type":"function"},{"doc":"precompile/2 works the same as the sigil syntax, only slightly more verbose.Pass precompile: false to not precompile the query during compilation.Pass generate_function: false to not create a function named after the operation name.Examplesdefmodule SomeTest do use Artem, schema: Your.Schema @query Artem.precompile(&quot; query { version } &quot;) end","ref":"Artem.html#precompile/2","title":"Artem.precompile/2","type":"macro"},{"doc":"Macroless version of precompile/2Pass in the schema as the second argumentExamples defmodule SomeTest do @query Artem.precompile(&quot; query { version } &quot;, Your.Schema) end","ref":"Artem.html#precompile/3","title":"Artem.precompile/3","type":"function"},{"doc":"Run a document against the schema.Examplesdefmodule SomeTest do use Artem, schema: Your.Schema @query ~q| query($format: String{ datetime(format: $format) } | test &quot;with assigned variables and context&quot; do @query |&gt; Artem.assign_variables(%{&quot;format&quot; =&gt; &quot;YYMMDD&quot;}) |&gt; Artem.assign_context(%{current_user_id: 1}) |&gt; Artem.run() end test &quot;with passed in variables and context&quot; do Artem.run(@query, variables: %{&quot;format&quot; =&gt; &quot;YYMMDD}, context: %{current_user_id: 1}) end end","ref":"Artem.html#run/2","title":"Artem.run/2","type":"function"},{"doc":"The q sigil can be used to precompile queries used in tests. It is a dynamic sigil in the sense that the resulting graphql query is run against the declared schema.Pass in the r modifier at the end of the sigil block to not precompile the query and use its 'raw' form. This will only parse the query when it is run in the tests.Examplesdefmodule SomeTest do use Artem, schema: Your.Schema @query ~q| query { version } | test &quot;runs precompiled query&quot; do Artem.run(@query) end @raw_query ~q| query { version } |r test &quot;runs raw query&quot; do Artem.run(@raw_query) end end","ref":"Artem.html#sigil_q/2","title":"Artem.sigil_q/2","type":"macro"},{"doc":"","ref":"Artem.Error.html","title":"Artem.Error","type":"exception"}]